<?php
/**
 * Template Name:Contacte 
 * The template for displaying all pages
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages and that other
 * 'pages' on your WordPress site will use a different template.
 *
 * @package i-excel
 * @since i-excel 1.0
 */

get_header(); ?>
	
	<?php global $post;     ?>
	
	<div id="primary" class="content-area nosidebar">
		<div id="content" class="site-content" role="main">

			<?php /* The loop */ ?>
			<?php while ( have_posts() ) : the_post(); ?>
			
				<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
			<?php if ( has_post_thumbnail() && ! post_password_required() ) : ?>
					<header class="entry-header">
						<div class="entry-thumbnail">
						<?php
							$large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id(), 'full' );
							echo '<a href="' . $large_image_url[0] . '" title="' . the_title_attribute( 'echo=0' ) . '" alt="" class="tx-colorbox">';
							the_post_thumbnail('iexcel-single-thumb');
							echo '</a>';
			?>
						</div>

					</header><!-- .entry-header -->
		<?php endif; ?>

					<div class="entry-content">
						<?php the_content(); ?>
						
						<?php
						$nom = $_POST['nom'];
						$cognoms = $_POST['cognoms'];
						$correu = $_POST['correu'];
						$telefon = $_POST['telefon'];
						$ciutat = $_POST['ciutat'];
						$tipologia = $_POST['tipologia'];
						$comentaris = $_POST['comentaris'];
						$num1 = $_POST['num1'];
						$num2 = $_POST['num2'];
						$robot = $_POST['robot'];

						if(isset($_POST['enviar']))
						{
							if($nom == '')
							{
								$errors[1] = '<span class="error"> Has d\'introduir el teu nom</span>';
							}
							else if($correu == '' or !preg_match("/^[a-zA-Z0-9_\.\-]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$/",$correu))
							{
								$errors[2] = '<span class="error"> Has d\'introduir una adreça correcta</span>';
							}
							else if($telefon == '' or !preg_match("/^[9|6|7|8][0-9]{8}$/",$telefon))
							{
								$errors[3] = '<span class="error"> El telèfon introduit no és correcte</span>';
							}
							else if($tipologia == '')
							{
								$errors[4] = '<span class="error"> Has d\'escollir que t\'interessa</span>';
							}
							else if($robot != $num1 + $num2)
							{
								$errors[5] = '<span class="error"> No has sumat bé</span>';
							}
							else
							{
								$dest = "cvilar@tinet.cat"; //Email de destino
								$subject = "Museu Joan Tapiol | Petitció de contacte";
								$cos = "En <strong> $nom $cognoms </strong> 
								<br /> està interessat en <strong> $tipologia </strong>
								<br /> és de <strong> $ciutat </strong>
								<br /> et pots posar en contacte amb ell a través del telèfon: <strong> $telefon </strong> 
								<br /> o el correu electrònic: <strong> $correu </strong>
								<br /> Ha afegit els següents comentaris: 
								<br /> $comentaris";
								//Cabeceras del correo
								$headers = "From: $nom <$correu>\r\n"; //Qui envia?
								$headers .= "X-Mailer: PHP5\n";
								$headers .= 'MIME-Version: 1.0' . "\n";
								$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n"; //
								
								if(mail($dest,$subject,$cos,$headers))
								{
									$result = '<div class="result_ok">Tot ha anat bé, aviat ens posarem en contacte</div>';
									// si l'enviament ha anat bé resetegem el que l'usuari ha escrt:
									$nom = "";
									$cognoms = "";
									$correu = "";
									$telefon = "";
									$ciutat = "";
									$tipologia = "";
									$comentaris ="";
									$robot = "";
								}
								else
								{
								$result = '<div class="result_fail"> Hi ha hagut un error a l\'enviar el missatge </div>';
								}
							}
						}
						?>

						<!-- Formulari de contacte -->
						
						<form id="form_contacte" action="" method="POST" name="form_contacte" enctype="multipart/form-data">
						<?php 
						if(isset($result)) { echo $result; } 
						?>
						<p>
						Els camps marcats amb un * són obligatoris 
						</p>
						<p>
						Nom:*
						<br /><input id="nom" class="required" maxlength="50" name="nom" type="text" value="<?php if(isset($nom)){ echo $nom; } ?>" /><?php if(isset($errors)){ echo $errors[1]; } ?> 
						</p>
						<p>
						Cognoms:
						<br /><input id="cognoms" class="required" maxlength="50" name="cognoms" type="text" value="<?php if(isset($cognoms)){ echo $cognoms; } ?>"/>
						</p>
						<p>
						Correu electrònic:*
						<br /><input id="correu" class="required" maxlength="50" name="correu" type="text" value="<?php if(isset($correu)){ echo $correu; } ?>" /><?php if(isset($errors)){ echo $errors[2]; } ?>
						</p>
						<p>
						Telèfon:*
						<br /><input id="telefon" class="required" maxlength="50" name="telefon" type="text" value="<?php if(isset($telefon)){ echo $telefon; } ?>"/><?php if(isset($errors)){ echo $errors[3]; } ?> 
						</p>
						<p>
						Ciutat:
						<br /><input id="ciutat" class="required" maxlength="50" name="ciutat" type="text" value="<?php if(isset($ciutat)){ echo $ciutat; } ?>"/>
						</p>
						<p>
						Estic interessat en:* <?php if(isset($errors)){ echo $errors[4]; } ?>
						<br /><select id="tipologia" name="tipologia">
						<option value="<?php if(isset($tipologia)){ echo $tipologia; } ?>"><?php echo $tipologia ?></option> 
						<option value="Exposicio">Exposició</option>
						<option value="-------">-------</option>
						<option value="Bodegons">Bodegons</option>
						<option value="Figura">Figura</option>
						<option value="Flors">Flors</option>
						<option value="Marina">Marina</option>
						<option value="Nu">Nu</option>
						<option value="Paisatge">Paisatge</option>
						<option value="Pintura-Religiosa">Pintura Religiosa</option>
						<option value="Retrat">Retrat</option>
						<option value="-------">-------</option>
						<option value="Sanguina">Sanguina</option>
						<option value="Carbó">Carbó</option>
						</select>
						</p>
						<p>
						Comentaris:
						<br /><textarea id="comentaris" class="required" cols="50" maxlength="2500" name="comentaris" rows="10"><?php if(isset($comentaris)){ echo $comentaris; } ?></textarea>
						</p>
						<p>
						No sóc un robot:*
						<br />Fes la suma de <?php echo $num1=rand(1,9) ?> + <?php echo $num2=rand(1,9)?> = <input id="robot" class="required" maxlength="10" name="robot" type="text" value="<?php if(isset($robot)){ echo $robot; } ?>" /><?php if(isset($errors)){ echo $errors[5]; } ?>
						<input type="hidden" name="num1" value="<?php echo $num1?>" />
						<input type="hidden" name="num2" value="<?php echo $num2?>" />
						</p>
						<input name="enviar" type="submit" value="Enviar" />
						</form>

					<?php wp_link_pages( array( 'before' => '<div class="page-links"><span class="page-links-title">' . __( 'Pages:', 'i-excel' ) . '</span>', 'after' => '</div>', 'link_before' => '<span>', 'link_after' => '</span>' ) ); ?>
					</div><!-- .entry-content -->

					<footer class="entry-meta">
						<?php edit_post_link( __( 'Edit', 'i-excel' ), '<span class="edit-link">', '</span>' ); ?>
					</footer><!-- .entry-meta -->
				</article><!-- #post -->

				<?php comments_template(); ?>
			<?php endwhile; ?>

		</div><!-- #content -->
	</div><!-- #primary -->

<?php get_footer(); ?>

